#include<cstdio>
#include<vector>
using namespace std;
vector<int> num[1005];
int main()
{
	int n,x,k;
	scanf("%d%d%d",&n,&x,&k);
	for(int i=1;i<=n;i++)
		num[i].push_back(i);
	while(k--)
	{
		int mid=n>>1;
		for(int i=1;i<=mid;i++)
			num[i].insert(num[i].end(),num[n-i+1].begin(),num[n-i+1].end());
		vector<int> use[1005];
		for(int i=1;i<=n;i++)
			use[i]=num[(i+1)>>1];
		for(int i=1;i<=n;i++)
			num[i]=use[i];
	}
	for(int i=0;i<num[x].size();i++)
	{
		if(i==num[x].size()>>1) puts("");
		printf("%2d ",num[x][i]);
	}
	return 0;
}